LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY IO_LATCH IS
	PORT
	(
		B_DATA		: IN	STD_LOGIC_VECTOR(7 downto 0);
		B_IOWN		: IN	STD_LOGIC;
		B_RESET		: IN	STD_LOGIC;
		IO_ADD		: IN	STD_LOGIC;
		DATA		: OUT	STD_LOGIC_VECTOR(7 downto 0));
END IO_LATCH;

ARCHITECTURE RTL OF IO_LATCH IS
	SIGNAL	WRITE	: STD_LOGIC;
begin
WRITE <= IO_ADD and not B_IOWN;
process(WRITE,B_RESET)
begin
	if (B_RESET='1') then
		DATA <= "00000000";
	else
		if (WRITE'event and WRITE='1') then
			DATA <= B_DATA(7 downto 0);
		end if;
	end if;
end process;
end RTL;


