LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;

ENTITY LATCHING IS
	PORT
	(
		USS_DATA		: IN	STD_LOGIC_VECTOR(7 downto 0);
		B_RESET			: IN	STD_LOGIC;
		DONE			: IN	STD_LOGIC;
		DATA			: OUT	STD_LOGIC_VECTOR(7 downto 0));
END LATCHING;

ARCHITECTURE RTL OF LATCHING IS
	SIGNAL	WRITE	: STD_LOGIC;
begin
WRITE <= DONE;
process(WRITE,B_RESET)
begin
	if (B_RESET='1') then
		DATA <= "00000000";
	else
		if (WRITE'event and WRITE='1') then
			DATA <= USS_DATA(7 downto 0);
		end if;
	end if;
end process;
end RTL;


