LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY OHTA IS
	PORT
	(
		DONE_F			: IN	STD_LOGIC;
		DONE_B			: IN	STD_LOGIC;
		DONE_R			: IN	STD_LOGIC;
		DONE_L			: IN	STD_LOGIC;
		ADD_F			: OUT	STD_LOGIC;
		ADD_B			: OUT	STD_LOGIC;
		ADD_R			: OUT	STD_LOGIC;
		ADD_L			: OUT	STD_LOGIC);
		
END OHTA;

ARCHITECTURE RTL OF OHTA IS
begin
		
process(DONE_F,DONE_B,DONE_R,DONE_L)
begin
	if rising_edge(DONE_F) then
		ADD_F <= '0';
		ADD_B <= '1';
		ADD_R <= '0';
		ADD_L <= '0';
	end if;
	
	if rising_edge(DONE_B) then
		ADD_F <= '0';
		ADD_B <= '0';
		ADD_R <= '1';
		ADD_L <= '0';
	end if;
	
	if rising_edge(DONE_R) then
		ADD_F <= '0';
		ADD_B <= '0';
		ADD_R <= '0';
		ADD_L <= '1';
	end if;
	
	if rising_edge(DONE_L) then
		ADD_F <= '1';
		ADD_B <= '0';
		ADD_R <= '0';
		ADD_L <= '0';
	end if;	

end process;
end RTL;
