-- ADDRESS DECORDER
--		Ver1.0	Date 2000.09.07
--				Produced by Simamu
--		Ver2.0	Date 2000.10.31
--				Produced by Simamu
--		Ver3.0	Date 2000.12.26
--				Produced by Simamu
--		Ver3.1	Date 2000.12.27
--				Produced by Simamu
--		Ver3.2	Date 2000.12.28
--				Produced by Simamu
--		Ver3.3	Date 2001.01.09
--				Produced by Simamu

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY ADD_DEC2 IS	
	PORT
	(
		SA													: IN	STD_LOGIC_VECTOR(15 DOWNTO 1);
		MPC_ADD0,MPC_ADD1									: OUT	STD_LOGIC;	--ADD0:Left ADD1:Right
		MPC_ADD2,MPC_ADD3									: OUT	STD_LOGIC;  --ADD2:Back ADD3:Front
		RE_ADD0,RE_ADD1										: OUT	STD_LOGIC;
		IO_ADD												: OUT	STD_LOGIC;
		F_USS_SMALL_ADD,F_USS_BIG_ADD,F_USS_BIG_ADD2		: OUT	STD_LOGIC;
		B_USS_SMALL_ADD,B_USS_BIG_ADD,B_USS_BIG_ADD2		: OUT	STD_LOGIC;
		R_USS_SMALL_ADD,R_USS_BIG_ADD,R_USS_BIG_ADD2		: OUT	STD_LOGIC;
		L_USS_SMALL_ADD,L_USS_BIG_ADD,L_USS_BIG_ADD2		: OUT	STD_LOGIC;
		GIO_ADD												: OUT	STD_LOGIC
	);
END ADD_DEC2;

ARCHITECTURE DATAFLOW OF ADD_DEC2 IS
BEGIN
PROCESS (SA)
BEGIN
	CASE SA IS
		-- 0310(Hex) for MPC_0 
		WHEN "000000110001000"	=>	MPC_ADD0 			<= '1';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
		-- 0312(Hex) for MPC_1							
		WHEN "000000110001001"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '1';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
		-- 0314(Hex) for MPC_2 
		WHEN "000000110001010"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '1';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
		-- 0316(Hex) for MPC_3							
		WHEN "000000110001011"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '1';
									RE_ADD0  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';							
		-- 0320(Hex) for RotaryEncoder_0(X)	
		WHEN "000000110010000"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '1';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
		-- 0322(Hex) for RotaryEncoder_1(Y)	
		WHEN "000000110010001"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '1';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
		-- 0324(Hex) for IO	
		WHEN "000000110010010"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '1';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
		-- 0326(Hex) for F_USS_SMALL	
		WHEN "000000110010011"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '1';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
		
		-- 0328(Hex) for F_USS_BIG	
		WHEN "000000110010100"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '1';
									F_USS_BIG_ADD2		<= '0';
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
		-- 0332(Hex) for B_USS_SMALL	
		WHEN "000000110011001"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '1';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';	
		-- 0334(Hex) for B_USS_BIG	
		WHEN "000000110011010"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '1';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';	
		-- 0336(Hex) for R_USS_SMALL	
		WHEN "000000110011011"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '1';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
		-- 0338(Hex) for R_USS_BIG	
		WHEN "000000110011100"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '1';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';	
		-- 0340(Hex) for L_USS_SMALL	
		WHEN "000000110100000"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '1';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';	
		-- 0342(Hex) for L_USS_BIG	
		WHEN "000000110100001"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '1';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';																																																																												
		-- 0300(Hex) for General_IO							
		WHEN "000000110000000"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '1';
		-- 0344(Hex) for F_USS_BIG2	
		WHEN "000000110100010"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '1';
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
		-- 0346(Hex) for B_USS_BIG2	
		WHEN "000000110100011"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '1';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
		-- 0348(Hex) for R_USS_BIG2	
		WHEN "000000110100100"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '1';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
		-- 0350(Hex) for L_USS_BIG2	
		WHEN "000000110101000"	=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '1';
									GIO_ADD				<= '0';																												
									
		WHEN OTHERS				=>	MPC_ADD0 			<= '0';
									MPC_ADD1 			<= '0';
									MPC_ADD2 			<= '0';
									MPC_ADD3 			<= '0';
									RE_ADD0  			<= '0';
									RE_ADD1  			<= '0';
									IO_ADD				<= '0';
									F_USS_SMALL_ADD		<= '0';
									F_USS_BIG_ADD		<= '0';
									F_USS_BIG_ADD2		<= '0';	
									B_USS_SMALL_ADD		<= '0';
									B_USS_BIG_ADD		<= '0';
									B_USS_BIG_ADD2		<= '0';
									R_USS_SMALL_ADD		<= '0';
									R_USS_BIG_ADD		<= '0';
									R_USS_BIG_ADD2		<= '0';
									L_USS_SMALL_ADD		<= '0';
									L_USS_BIG_ADD		<= '0';
									L_USS_BIG_ADD2		<= '0';
									GIO_ADD				<= '0';
	END CASE;
END PROCESS;
END DATAFLOW;

